Bug 1009145 - ldconfig warns of mismatch elf e_flags on armv7hl on upgrade
ldconfig warns of mismatch elf e_flags on armv7hl on upgrade
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: glibc (Show other bugs)
20
arm Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Carlos O'Donell
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-17 15:10 EDT by Kyle McMartin
Modified: 2016-11-24 07:19 EST (History)
10 users (show)

See Also:
Fixed In Version: glibc-2.18-11.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-10-09 10:29:32 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
ldconfig armhfp (1008 bytes, patch)
2013-09-17 15:10 EDT, Kyle McMartin
no flags Details | Diff
rawhide glibc.spec with fix included. (242.21 KB, text/x-rpm-spec)
2013-09-25 14:36 EDT, Carlos O'Donell
no flags Details
rawhide patch file for fix. (851 bytes, patch)
2013-09-25 14:36 EDT, Carlos O'Donell
no flags Details | Diff

  None (edit)
Description Kyle McMartin 2013-09-17 15:10:24 EDT
Created attachment 798943 [details]
ldconfig armhfp

The version of binutils in F-20 was regressed from F-19 briefly, which resulted in our soft/hard float flags disappearing in libraries compiled in the F-20 mass rebuild.

I've backported the patch into the F-20 binutils, but in order to avoid the ldconfig complaints on upgrades from F-19 to F-20, we either need to do something about the warning, or mass rebuild F-20 on armv7hl which isn't in the schedule.

So, I've written a (admittedly, massively gross) patch for ldconfig which avoids the issue if the hfp flag has gone missing from e_flags.

Carlos, I'd appreciate your input on this.

--Kyle
Comment 1 Carlos O'Donell 2013-09-23 02:57:35 EDT
Kyle,

I would change the check to be a more conservative:

dlib_ptr->flag & FLAG_ARM_LIBHF &&
((flag & FLAG_ARM_LIBHF)
 || (flag & FLAG_ARM_LIBSF)
 || (flag & FLAG_ELF_LIBC6))

This mirrors the kind of check we have already done in other places to capture the transitional nature of this change.

Then wrap it all in #ifdef __arm__ / #endif to avoid it being used on x86-64.

Would you like me to check something like this into rawhide and f20?

Cheers,
Carlos.
Comment 2 Carlos O'Donell 2013-09-23 03:03:12 EDT
The most conservative check is actually:

dlib_ptr->flag & FLAG_ARM_LIBHF &&
(flag & FLAG_ELF_LIBC6))

Which is what would probably be best e.g. was previously LIBHF and is now unmarked.

c.
Comment 3 Kyle McMartin 2013-09-23 13:24:32 EDT
This is fine with me.
Comment 4 Carlos O'Donell 2013-09-23 17:15:35 EDT
(In reply to Kyle McMartin from comment #3)
> This is fine with me.

Perfect, I'll pitch something into rawhide and f20 and give blc a poke when I have a build ready for testing.

c.
Comment 5 Carlos O'Donell 2013-09-25 14:27:41 EDT
Scratch rawhide build with fix building here:

http://koji.fedoraproject.org/koji/taskinfo?taskID=5984332
Comment 6 Carlos O'Donell 2013-09-25 14:34:35 EDT
OK, rawhide buildroots broken, I'll build a rpm by hand.
Comment 7 Carlos O'Donell 2013-09-25 14:36:18 EDT
Created attachment 803014 [details]
rawhide glibc.spec with fix included.
Comment 8 Carlos O'Donell 2013-09-25 14:36:56 EDT
Created attachment 803015 [details]
rawhide patch file for fix.
Comment 9 Carlos O'Donell 2013-09-27 14:49:03 EDT
Rawhide scratch build complete:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5989387
Comment 10 Carlos O'Donell 2013-09-30 15:08:56 EDT
f20 scratch build complete:
http://koji.fedoraproject.org/koji/taskinfo?taskID=6006489
Comment 11 Carlos O'Donell 2013-09-30 16:40:06 EDT
Kyle,

Care to test the new f20 packages?
Comment 12 Brendan Conoboy 2013-09-30 19:57:46 EDT
I've tested this on my f20 alpha-ish trimslice by using yum to reinstall all packages providing /lib/*.so*.  Before testing the f20 scratch build this produced warnings every time ldconfig ran.  With the f20 scratch build no warnings were generated.
Comment 13 Carlos O'Donell 2013-10-02 21:40:13 EDT
Fixed in rawhide and f20.

We'll push out a build shortly.
Comment 14 Fedora Update System 2013-10-03 06:57:36 EDT
glibc-2.18-11.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/glibc-2.18-11.fc20
Comment 15 Fedora Update System 2013-10-03 21:57:40 EDT
Package glibc-2.18-11.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing glibc-2.18-11.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-18239/glibc-2.18-11.fc20
then log in and leave karma (feedback).
Comment 16 Fedora Update System 2013-10-09 10:29:32 EDT
glibc-2.18-11.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 17 Kyle McMartin 2014-09-15 16:48:20 EDT
clearing needinfo.

Note You need to log in before you can comment on or make changes to this bug.